/**
  *  \file planetscentral/talk/smiley.h
  *  \brief Talk: Smileys
  */
#ifndef C2SERVER_PLANETSCENTRAL_TALK_SMILEY_H
#define C2SERVER_PLANETSCENTRAL_TALK_SMILEY_H

#include "cpluslib/string.h"
#include "cpluslib/smallset.h"

/** Defines a smiley. */
struct Smiley {
    /** Canonical name of smiley ("wink"). */
    const char* name;

    /** Symbol of smiley (";-)"). */
    const char* symbol;

    /** Alternative symbol. */
    const char* symbol2;

    /** Name of image file ("res/smileys/wink.png"). */
    const char* image;

    /** Size of image file to use in forum. */
    short width, height;
};

const Smiley* lookupSmiley(const string_t& name);


struct InlineInfo {
    /** Type of element. */
    enum What {
        Smiley,
        Link
    };
    What what;

    /** Starting position of element in string passed by user (start deleting here). */
    string_t::size_type start;

    /** Length of element in string passed by user (delete this many characters). */
    string_t::size_type length;

    /** Informational text (smiley name, URL, ...). */
    string_t text;
};

typedef SmallSet<InlineInfo::What> InlineItemSet;

bool findInlineElement(const string_t& text,
                       string_t::size_type start_at,
                       InlineItemSet what,
                       InlineInfo& info);

#endif
